!**************************************************
!NayspW[
!**************************************************
module nayslib

  implicit none
  
  private
  integer(4), parameter :: STRLEN = 256
  logical :: debugflg = .false. 
  integer(4) :: gmode              !=0:ŒiqC=1:ړiq
  integer(4) :: input_unit         !o̓t@C̑uԍ
  integer(4) :: out_unit           !o̓t@C̑uԍ
  !integer(4) :: cur = -1           !o͏tO
  character(len = STRLEN) :: cur            !o͏tO

  public :: nayslib_input_grid       !NaysPreo͂iqf[^ǂݍ

  public :: nayslib_open_output      !NaysPostp̏o̓t@CJ
  public :: nayslib_close_output     !NaysPostp̏o̓t@C
  public :: nayslib_output_time      !NaysPostpɌvZo͂
  public :: nayslib_output_cond2d    !NaysPostpɏo͏o͂
  public :: nayslib_output_grid2d    !NaysPostpɊiqo͂
  public :: nayslib_output_vec2d     !NaysPostpɃxNgʂo͂
  public :: nayslib_output_scl2d     !NaysPostpɃXJʂo͂

  public :: nayslib_output_cond3d    !NaysPostpɏo͏o͂
  public :: nayslib_output_grid3d    !NaysPostpɊiqo͂
  public :: nayslib_output_vec3d     !NaysPostpɃxNgʂo͂
  public :: nayslib_output_scl3d     !NaysPostpɃXJʂo͂

  public :: nayslib_gen_normal_3d_grid    !NaysPreœǂݍ񂾃f[^3Diqɕϊ()
  public :: nayslib_gen_ratio_3d_grid     !NaysPreœǂݍ񂾃f[^3Diqɕϊ()

  public :: nayslib_get_file     !NaysPrěvZ^ǂݍ
  public :: nayslib_get_string     !NaysPrěvZ^ǂݍ
  public :: nayslib_get_integer     !NaysPrěvZ^ǂݍ
  public :: nayslib_get_real     !NaysPrěvZ^ǂݍ
  public :: nayslib_get_logical     !NaysPrěvZ_^ǂݍ

  public :: nayslib_get_stringList     !NaysPrěvZ_^ǂݍ 
  public :: nayslib_get_integerList     !NaysPrěvZ_^ǂݍ
  public :: nayslib_get_realList     !NaysPrěvZ_^ǂݍ
  
  public :: nayslib_get_string_list     !NaysPrěvZXg^ǂݍ
  public :: nayslib_get_integer_list     !NaysPrěvZXg^ǂݍ
  public :: nayslib_get_real_list     !NaysPrěvZ񃊃Xg^ǂݍ
  public :: nayslib_get_logical_list     !NaysPrěvZ_^Xg^ǂݍ

!  public :: getcoordsize            !NaysPreo͂iqf[^iqTCYǂݍ
!  public :: getcoord                !NaysPreo͂iqf[^iqf[^ǂݍ

  !C^[tFCX
  interface

     !񃊃Xg^̎擾
     subroutine get_stringList(ifile, label)
        implicit none
        character(*), intent(in) :: ifile, label
     end subroutine get_stringList
     
     !Xg^̎擾
     subroutine get_integerList(ifile, label)
        implicit none
        character(*), intent(in) :: ifile, label
     end subroutine get_integerList
     
     !Xg^̎擾
     subroutine get_realList(ifile, label)
        implicit none
        character(*), intent(in) :: ifile, label
     end subroutine get_realList





     !^Xg^̎擾
     subroutine get_string_list(label, num, pval)
       character(*), intent(in) :: label
       integer(4) :: num
       character(len = 256), dimension(:), pointer :: pval
     end subroutine get_string_list

     !Xg^̎擾
     subroutine get_integer_list(label, num, pval)
       character(*), intent(in) :: label
       integer(4) :: num
       integer(4), dimension(:), pointer :: pval
     end subroutine get_integer_list

     !Xg^̎擾
     subroutine get_real_list(label, num, pval)
       character(*), intent(in) :: label
       integer(4) :: num
       real(8), dimension(:), pointer :: pval
     end subroutine get_real_list

     !_^Xg^̎擾
     subroutine get_logical_list(label, num, pval)
       character(*), intent(in) :: label
       integer(4) :: num
       logical, dimension(:), pointer :: pval
     end subroutine get_logical_list
     
     !NaysPreœǂݍ񂾃f[^3Diqɕϊ
     subroutine gen_normal_3d_grid(nx, ny, nz, x2d, y2d, el, hh, o2d, x3d, y3d, z3d, o3d, hmin)
       integer(4), intent(in) :: nx, ny, nz
       real(8) :: hmin
       integer(4), dimension(:,:), pointer :: o2d
       real(8), dimension(:,:), pointer :: x2d, y2d
       real(8), dimension(:,:), pointer :: el, hh
       integer(4), dimension(:,:,:), pointer :: o3d
       real(8), dimension(:,:,:), pointer :: x3d, y3d, z3d
     end subroutine gen_normal_3d_grid
     
     !NaysPreœǂݍ񂾃f[^3Diqɕϊ
     subroutine gen_ratio_3d_grid(nx, ny, nz, z0, x2d, y2d, el, hh, o2d, x3d, y3d, z3d, o3d, hmin)
       integer(4), intent(in) :: nx, ny, nz
       real(8) :: hmin, z0
       integer(4), dimension(:,:), pointer :: o2d
       real(8), dimension(:,:), pointer :: x2d, y2d
       real(8), dimension(:,:), pointer :: el, hh
       integer(4), dimension(:,:,:), pointer :: o3d
       real(8), dimension(:,:,:), pointer :: x3d, y3d, z3d
     end subroutine gen_ratio_3d_grid
     
     !NaysPreo͂iqf[^ǂݍ
     subroutine input_grid(gridfile, nx, ny, xx, yy, z0, z1, iobst, obst, hmin)
       character(*), intent(in) :: gridfile                !iqt@C
       real(8) :: hmin                                      !Œᐅ[
       integer(4), intent(out) :: iobst                    !QtOCiq̕ωtO
       integer(4), intent(out) :: nx, ny                   !iq: x(), y()
       integer(4), dimension(:,:), pointer :: obst         !\ZtO
       real(8), dimension(:,:), pointer :: xx, yy          !Wl: x, y
       real(8), dimension(:,:), pointer :: z0, z1          !z0(͏), z1()
     end subroutine input_grid
     
     !NaysPostp̏o̓t@CJ
     subroutine open_output(fname, imode)
       character(*), intent(in) :: fname
       integer(4), intent(in) :: imode
     end subroutine open_output
     
     !NaysPostp̏o̓t@C
     subroutine close_output
       
     end subroutine close_output
     
     !NaysPostpɌvZo͂
     subroutine output_time(time)
       real(8), intent(in) :: time
     end subroutine output_time
     
     !NaysPostpɏo͏o͂
     subroutine output_cond2d(nx, ny, iobst, nphys, label, dim)
       integer(4), intent(in) :: iobst                     !QtOCiq̕ωtO
       integer(4), intent(in) :: nx, ny                    !iq: x(), y()
       integer(4), intent(in) :: nphys                     !o͕ʂ̐
       character(*), dimension(:), intent(in) :: label     !ʂ̃x
       integer(4), dimension(:), intent(in) :: dim         !ʂ̎
     end subroutine output_cond2d
     
     !NaysPostpɊiqo͂
     subroutine output_grid2d(nx, ny, xx, yy, z0, z1, iobst, obst)
       integer(4), intent(in) :: iobst                     !QtO
       integer(4), intent(in) :: nx, ny                    !iq: x(), y()
       integer(4), dimension(:,:), intent(in) :: obst      !\tO
       real(8), dimension(:,:), intent(in) :: xx, yy       !Wl: x, y
       real(8), dimension(:,:), intent(in) :: z0, z1       !z0(͏), z1()
     end subroutine output_grid2d
     
     !NaysPostpɃxNgʂo͂
     subroutine output_vec2d(label, nx, ny, uu, vv)
       character(*), intent(in) :: label                   !ʂ̃x  
       integer(4), intent(in) :: nx, ny                    !iq          
       real(8), dimension(:,:), intent(in) :: uu, vv       !ʁixNgj
     end subroutine output_vec2d
     
     !NaysPostpɃXJʂo͂
     subroutine output_scl2d(label, nx, ny, val)
       character(*), intent(in) :: label                   !ʂ̃x
       integer(4), intent(in) :: nx, ny                    !iq
       real(8), dimension(:,:), intent(in) :: val          !ʁiXJj  
     end subroutine output_scl2d
     
     !NaysPostpɏo͏o͂
     subroutine output_cond3d(nx, ny, nz, iobst, nphys, label, dim)
       integer(4), intent(in) :: iobst                     !QtOCiq̕ωtO
       integer(4), intent(in) :: nx, ny, nz                !iq: x(), y()
       integer(4), intent(in) :: nphys                     !o͕ʂ̐
       character(*), dimension(:), intent(in) :: label     !ʂ̃x
       integer(4), dimension(:), intent(in) :: dim         !ʂ̎
     end subroutine output_cond3d
     
     !NaysPostpɊiqo͂
     subroutine output_grid3d(nx, ny, nz, xx, yy, zz, iobst, obst)
       integer(4), intent(in) :: iobst                     !QtO
       integer(4), intent(in) :: nx, ny, nz                !iq: x(), y()
       integer(4), dimension(:,:,:), intent(in) :: obst    !\tO
       real(8), dimension(:,:,:), intent(in) :: xx, yy, zz     !Wl: x, y
     end subroutine output_grid3d
     
     !NaysPostpɃxNgʂo͂
     subroutine output_vec3d(label, nx, ny, nz, uu, vv, ww)
       character(*), intent(in) :: label                   !ʂ̃x  
       integer(4), intent(in) :: nx, ny, nz                !iq          
       real(8), dimension(:,:,:), intent(in) :: uu, vv, ww !ʁixNgj
     end subroutine output_vec3d
     
     !NaysPostpɃXJʂo͂
     subroutine output_scl3d(label, nx, ny, nz, val)
       character(*), intent(in) :: label                   !ʂ̃x
       integer(4), intent(in) :: nx, ny, nz                !iq
       real(8), dimension(:,:,:), intent(in) :: val        !ʁiXJj  
     end subroutine output_scl3d
     
  end interface
   
  
contains

  !======================================================================
  !NaysPreœǂݍ񂾃f[^3Diqɕϊ:(Ԋu)
  !======================================================================
  subroutine nayslib_gen_normal_3d_grid(nx, ny, nz, x2d, y2d, el, hh, o2d, x3d, y3d, z3d, o3d, hmin)
    integer(4), intent(in) :: nx, ny, nz
    real(8) :: hmin
    integer(4), dimension(:,:), pointer :: o2d
    real(8), dimension(:,:), pointer :: x2d, y2d
    real(8), dimension(:,:), pointer :: el, hh
    integer(4), dimension(:,:,:), pointer :: o3d
    real(8), dimension(:,:,:), pointer :: x3d, y3d, z3d

    integer(4) :: i, j, k                                        !JE^
    integer(4) :: ierr, grid_size, cell_size                     !workpϐ
    real(8) :: depth, delta
    integer(4), dimension(:,:,:), allocatable, save :: wo          !\tO
    real(8), dimension(:,:,:), allocatable, save :: wx, wy, wz     !Wl: x, y, z
    !--------------------------------------------------
    if(debugflg) write(*,*) "start:transfort coordinates 2d to 3d"

    !2ȏł
    if(nz < 2) then
       write(*,*) "err: nz must be greater than 1"
        stop
    end if

    !GÅm
    allocate(wx(1:nx, 1:ny, 1:nz), stat = ierr)
    allocate(wy(1:nx, 1:ny, 1:nz), stat = ierr)
    allocate(wz(1:nx, 1:ny, 1:nz), stat = ierr)
    allocate(wo(1:nx-1, 1:ny-1, 1:nz-1), stat = ierr)
    if (ierr/=0)  then
       write(*,*) 'error : fail to allocate stat=',ierr; stop   !GA擾ɎsƂ
    end if

    !iq̕ϊ
    do i = 1, nx
       do j = 1, ny

          ![
          depth = hh(i,j) - el(i,j)
          
          ![hminȏłȂ΂ȂȂ
          if(depth < hmin) then

             depth = hmin
!             write(*,*) "err: depth musut be be greater than 1E-03"
!             stop
          end if

          !
          delta = depth/(nz-1)
          
          do k = 1, nz
             wx(i,j,k) = x2d(i,j)
             wy(i,j,k) = y2d(i,j)

             !zWl̐ݒ
             wz(i,j,k) = el(i,j)+delta*(k-1)
          end do
       end do
    end do

    !ZtO̕ϊ
    do i = 1, nx-1
       do j = 1, ny-1
          do k = 1, nz-1
             wo(i,j,k) = o2d(i,j)
          end do
       end do
    end do

    !|C^ϐ̎wݒ
    allocate(x3d(1:nx, 1:ny, 1:nz), stat = ierr)
    allocate(y3d(1:nx, 1:ny, 1:nz), stat = ierr)
    allocate(z3d(1:nx, 1:ny, 1:nz), stat = ierr)
    allocate(o3d(1:nx-1, 1:ny-1, 1:nz-1), stat = ierr)
    if (ierr/=0)  then
       write(*,*) 'error : fail to allocate stat=',ierr; stop   !GA擾ɎsƂ
    end if

    x3d = wx
    y3d = wy
    z3d = wz
    o3d = wo

    if(debugflg) write(*,*) "done..."
    !--------------------------------------------------
  end subroutine nayslib_gen_normal_3d_grid


  !======================================================================
  !NaysPreœǂݍ񂾃f[^3Diqɕϊ:()
  !======================================================================
  subroutine nayslib_gen_ratio_3d_grid(nx, ny, nz, z0, x2d, y2d, el, hh, o2d, x3d, y3d, z3d, o3d, hmin)
    integer(4), intent(in) :: nx, ny, nz
    real(8) :: hmin, z0
    integer(4), dimension(:,:), pointer :: o2d
    real(8), dimension(:,:), pointer :: x2d, y2d
    real(8), dimension(:,:), pointer :: el, hh
    integer(4), dimension(:,:,:), pointer :: o3d
    real(8), dimension(:,:,:), pointer :: x3d, y3d, z3d

    integer(4) :: i, j, k                                        !JE^
    integer(4) :: ierr, grid_size, cell_size                     !workpϐ
    real(8) :: depth, delta, ratio
    integer(4), dimension(:,:,:), allocatable, save :: wo          !\tO
    real(8), dimension(:,:,:), allocatable, save :: wx, wy, wz     !Wl: x, y, z
    !--------------------------------------------------
    if(debugflg) write(*,*) "start:transfort coordinates 2d to 3d"

    !2ȏł
    if(nz < 2) then
       write(*,*) "err: nz must be greater than 1"
        stop
    end if
    
    !hminz0̐ƂĂȂ
    if(z0 > hmin) then
        write(*,*) "z0 should be less than hmin."
        stop
    end if

    !GÅm
    allocate(wx(1:nx, 1:ny, 1:nz), stat = ierr)
    allocate(wy(1:nx, 1:ny, 1:nz), stat = ierr)
    allocate(wz(1:nx, 1:ny, 1:nz), stat = ierr)
    allocate(wo(1:nx-1, 1:ny-1, 1:nz-1), stat = ierr)
    if (ierr/=0)  then
       write(*,*) 'error : fail to allocate stat=',ierr; stop   !GA擾ɎsƂ
    end if

    !iq̕ϊ
    do i = 1, nx
       do j = 1, ny

          ![
          depth = hh(i,j) - el(i,j)
          
          ![1mmȏłȂ΂ȂȂ
          if(depth < 1E-3) then

             depth = 1E-3
!             write(*,*) "err: depth musut be be greater than 1E-03"
!             stop
          end if

          !擾
          ratio = get_ratio(depth, nz, z0)
          
          !Xebvl
          delta = z0
          
          do k = 1, nz
             wx(i,j,k) = x2d(i,j)
             wy(i,j,k) = y2d(i,j)

             !zWl̐ݒ
             if(k == 1) then
                wz(i,j,k) = el(i,j)
             
             else
                wz(i,j,k) = wz(i,j,k-1) + delta
                
             end if
             
             !Xebv̍XV
             delta = delta * ratio
          end do
       end do
    end do

    !ZtO̕ϊ
    do i = 1, nx-1
       do j = 1, ny-1
          do k = 1, nz-1
             wo(i,j,k) = o2d(i,j)
          end do
       end do
    end do

    !|C^ϐ̎wݒ
    allocate(x3d(1:nx, 1:ny, 1:nz), stat = ierr)
    allocate(y3d(1:nx, 1:ny, 1:nz), stat = ierr)
    allocate(z3d(1:nx, 1:ny, 1:nz), stat = ierr)
    allocate(o3d(1:nx-1, 1:ny-1, 1:nz-1), stat = ierr)
    if (ierr/=0)  then
       write(*,*) 'error : fail to allocate stat=',ierr; stop   !GA擾ɎsƂ
    end if

    x3d = wx
    y3d = wy
    z3d = wz
    o3d = wo

    if(debugflg) write(*,*) "done..."
    !--------------------------------------------------
  end subroutine nayslib_gen_ratio_3d_grid

  !======================================================================
  !Ԃ֐:
  !======================================================================
  function get_ratio(delta, num, a0)
    real(8) :: get_ratio
    real(8) :: delta          !
    real(8) :: a0             !
    integer(4) :: num         !
    
    real(8) :: ratio0, r, dd           !workϐ
    real(8) :: ratio                   !
    real(8) :: c1, c2, c3              !Newton@萔
    real(8) :: F, Fd                   !Newton@萔
    integer(4) :: Count, isw           !JE^, tO
    integer(4) :: MaxCount = 100       !Newton@ő
    real(8) :: Eps = 1E-06             !Newton@ő
    
    !Newton@̏l
    ratio0 = delta / (a0 * num)
    
    !䂪1傫
    if(ratio0 > 1) then
       do r = 1.1, 10, 0.1
            dd = a0 * (1. - r ** num) / (1. - r)
            If(dd > delta) then
                exit
            End If
        end do
    
    !䂪1菬  
    else
        do r = 0.9, 0.1, -0.1
            dd = a0 * (1. - r ** num) / (1. - r)
            If(dd < delta) Then
                exit
            End If
        end do

    end if  
    
    !l
    ratio = r
    
    !Newton@̒萔ݒ
    c1 = a0/delta
    c2 = -1.
    c3 = 1. - c1
    
    isw = -1
    do Count = 1, MaxCount
        F = c1 * ratio ** (num) + c2 * ratio + c3
        Fd = c1 * num * ratio ** (num - 1) + c2

        If (abs(F) < Eps) then
            isw = 1
            exit
        end if
        ratio = ratio - F / Fd
    end do
        
    !G[
    if(isw == -1) then
        write(*,*) "err: divide setting is nonconformity. raito divide."
        stop
    end if

    !Ԃ
    get_ratio = ratio
  
  
  end function get_ratio

  !======================================================================
  !vZiq̓ǂݍ:
  !======================================================================
  subroutine nayslib_input_grid(gridfile, nx, ny, xx, yy, z0, z1, iobst, obst, hmin)
    character(*), intent(in) :: gridfile                !iqt@C
    real(8) :: hmin
    integer(4), intent(out) :: iobst                    !QtOCiq̕ωtO
    integer(4), intent(out) :: nx, ny                   !iq: x(), y()
    integer(4), dimension(:,:), pointer :: obst         !\ZtO
    real(8), dimension(:,:), pointer :: xx, yy          !Wl: x, y
    real(8), dimension(:,:), pointer :: z0, z1          !z0(͏), z1()

    integer(4) :: i, j, k                                     !JE^
    integer(4) :: nz                                          !ziq
    integer(4) :: ierr, grid_size, cell_size                  !workpϐ
    real(8) :: delta
    integer(4), dimension(:,:), allocatable, save :: o     !\tO
    real(8), dimension(:,:), allocatable, save :: x, y     !Wl: x, y
    real(8), dimension(:,:), allocatable, save :: g0, g1   !z0(͏), z1()
    !--------------------------------------------------
    if(debugflg) write(*,*) "start:input coordinates"

    !uԍ擾
    input_unit = get_unit_no()

    !t@CJ
    open(input_unit,file = trim(gridfile), status = "old", form = "unformatted", iostat = ierr)
    if(ierr /= 0) then
        write(*,*) "err: file open error. error number is", ierr
        stop
    end if

    !iqTCY擾
    call getcoordsize(nx, ny, nz, iobst)

    !|C^ϐ̃GAm
    allocate( xx(1:nx, 1:ny), stat = ierr)
    allocate( yy(1:nx, 1:ny), stat = ierr)
    allocate( z0(1:nx, 1:ny), stat = ierr)
    allocate( z1(1:nx, 1:ny), stat = ierr)
    allocate( obst(1:nx-1, 1:ny-1), stat = ierr)

    ![Jϐ̃GAm
    allocate ( x(1:nx, 1:ny), stat = ierr)
    allocate ( y(1:nx, 1:ny), stat = ierr)
    allocate ( g0(1:nx, 1:ny), stat = ierr)
    allocate ( g1(1:nx, 1:ny), stat = ierr)
    allocate ( o(1:nx-1, 1:ny-1), stat = ierr)
    if (ierr/=0)  then
       write(*,*) 'error : fail to allocate stat=',ierr; stop   !GA擾ɎsƂ
    end if

    !Wl̎擾
    call getcoord(nx, ny, nz, iobst, x, y, g0, g1, o)

    !t@C
    close(input_unit)
    
    ![hmin菬Ƃ́CŒᐅ[ɂ
    do i = 1, nx
        do j = 1, ny
            delta = g1(i,j) - g0(i,j)
            
            if(delta < hmin) then
                g1(i,j) = g0(i,j) + hmin
            end if
        end do
    end do

    !|C^ϐ̎wݒ
    xx = x
    yy = y
    z0 = g0
    z1 = g1
    obst = o

    if(debugflg) write(*,*) "done..."
  end subroutine nayslib_input_grid

  !======================================================================
  !  @brief z̃GAǂݍݒlԂ
  !  @param fname(in)   iqt@C
  !  @param nx(out)     Xiq
  !  @param ny(out)     Yiq
  !  @param nz(out)     Ziq
  !  @param iobst(out)  QZ݃tO
  !======================================================================
  subroutine getcoordsize(nx, ny, nz, iobst)
    integer(4), intent(out) :: nx, ny, nz, iobst
    !--------------------------------------------------
    if(debugflg) write(*,*) "start: getcoordsize"

    read(input_unit) nx, ny, nz, iobst

    !Ziq2ȏ
    if(nz /= 2) then
       write(*,*) "err: nz must be 2. current nz = ", nz
       stop
    end if

    if(debugflg) write(*,*) "done..."
    !--------------------------------------------------
  end subroutine getcoordsize

  !======================================================================
  !  @brief z̃GAǂݍݒlԂ
  !  @param fname(in)   iqt@C
  !  @param nx(in)      Xiq
  !  @param ny(in)      Yiq
  !  @param nz(in)      Ziq
  !  @param iobst(in)   Q݃ZtO
  !  @param xx(out)     Xiq
  !  @param yy(out)     Yiq
  !  @param z0(out)     Ziq(͏)
  !  @param z1(out)     Ziq()
  !  @param obst(out)   QZtO
  !======================================================================
  subroutine getcoord(nx, ny, nz, iobst, xx, yy, z0, z1, obst)
    integer(4), intent(in) :: nx, ny, nz, iobst
    integer(4), dimension(:,:), intent(out) :: obst
    real(8), dimension(:,:), intent(out) :: xx, yy, z0, z1
  
    integer(4) :: idummy
    integer(4) :: i, j, k
    integer(4), dimension(1:nx-1, 1:ny-1, 1:nz-1) :: o3
    real(8), dimension(1:nx, 1:ny, 1:nz) :: x3, y3, z3
    !--------------------------------------------------
    if(debugflg) write(*,*) "start: getcoord"

    !Wl
    read(input_unit) (((x3(i,j,k),i=1, nx), j=1, ny), k=1, nz) &
         & , (((y3(i,j,k),i=1, nx), j=1, ny), k=1, nz) &
         & , (((z3(i,j,k),i=1, nx), j=1, ny), k=1, nz)

    do j=1, ny
       do i=1, nx
          xx(i,j) = x3(i,j,1)
          yy(i,j) = y3(i,j,1)
          z0(i,j) = z3(i,j,1)
          z1(i,j) = z3(i,j,2)
       end do
    end do


    !ZtO
    if(iobst == 1) then
       read(input_unit) (((o3(i,j,k),i=1, nx-1), j=1, ny-1), k=1, nz-1)
       do j = 1, ny-1
          do i = 1, nx-1
             obst(i,j) = o3(i, j, 1)
          end do
       end do
    else
       do j = 1, ny-1
          do i = 1, nx-1
             obst(i,j) = 0
          end do
       end do
    end if

    if(debugflg) write(*,*) "done..."
    !--------------------------------------------------
  end subroutine getcoord

  !======================================================================
  !Nayspo̓t@CJ
  !======================================================================
  subroutine nayslib_open_output(fname, imode)
    character(*), intent(in) :: fname
    integer(4), intent(in) :: imode
    
    integer(4) :: ierr
    !--------------------------------------------------
    if(debugflg) write(*,*) "open file for nays"
    !iq[h =0:ŒiqC=1:ړiqCȊOG[
    gmode = imode
    if(gmode > 1 .or. gmode < 0) then
       write(*,*) "error: unknown grid mode."
       stop
    end if

    !o̓t@Cp̑uԍ擾
    out_unit = get_unit_no()
    open(out_unit, file = trim(fname), status = "unknown", form="unformatted", iostat = ierr)
        if(ierr /= 0) then
        write(*,*) "err: err number is", ierr
        stop
    end if
    if(debugflg) write(*,*) "done..."

    !tO
    cur = "open_output"

  end subroutine nayslib_open_output

  !======================================================================
  !Naysp@o̓t@C
  !======================================================================
  subroutine nayslib_close_output
    !--------------------------------------------------
    if(debugflg) write(*,*) "current status = ", trim(cur)

    !t@CI[vXe[^X
    if(isopen(out_unit) /= 0) then
       write(*,*) "error: output file is not opened."
       stop
    end if

    if(debugflg) write(*,*) "close file for nays"
    close(out_unit)
    if(debugflg) write(*,*) "done..."

    !tO
    cur = "close_output"

  end subroutine nayslib_close_output

  !======================================================================
  !̏o
  !======================================================================
  subroutine nayslib_output_time(time)
    real(8), intent(in) :: time
    !--------------------------------------------------
    if(debugflg) write(*,*) "current status = ", trim(cur)

    !o̓t@Cւ̏o͏̊mF
    !Œiq
    if(gmode == 0) then
        if(trim(cur) == "output_grid2d" &
            .or. trim(cur) == "output_vec2d"&
            .or. trim(cur) == "output_scl2d"&
            .or. trim(cur) == "output_grid3d"&
            .or. trim(cur) == "output_vec3d"&
            .or. trim(cur) == "output_scl3d" ) then
	    else   
            write(*,*) "error: writing order for output file is wrong."
	    stop
        end if
    
    !ړiq
    else if(gmode == 1) then
        if(trim(cur) == "output_cond2d" &
            .or. trim(cur) == "output_vec2d" &
            .or. trim(cur) == "output_scl2d" &
	    .or. trim(cur) == "output_cond3d" &
            .or. trim(cur) == "output_vec3d" &
            .or. trim(cur) == "output_scl3d") then
        else
            write(*,*) "error: writing order for output file is wrong."
	    stop
        end if
    end if

    !t@CI[vXe[^X
    if(isopen(out_unit) /= 0) then
       write(*,*) "error: output file is not opened."
       stop
    end if

    if(debugflg) write(*,*) "output time = ", time

    write(out_unit) time

    if(debugflg) write(*,*) "done..."

    !tO
    cur = "output_time"

  end subroutine nayslib_output_time

  !======================================================================
  !Naysp@o͏L
  !======================================================================
  subroutine nayslib_output_cond2d(nx, ny, iobst, nphys, label, dim)
    !ziq
    integer(4)   :: nz
    parameter(nz = 2)

    integer(4), intent(in) :: iobst                     !QtOCiq̕ωtO
    integer(4), intent(in) :: nx, ny                    !iq: x(), y()
    integer(4), intent(in) :: nphys                     !o͕ʂ̐
    character(*), dimension(:), intent(in) :: label     !ʂ̃x
    integer(4), dimension(:), intent(in) :: dim         !ʂ̎

    !JE^
    integer(4) :: l
    !--------------------------------------------------
    if(debugflg) write(*,*) "current status = ", trim(cur)

    if(trim(cur) /= "open_output") then
        write(*,*) "error: writing order for output file is wrong."
	stop
    end if

    !t@CI[vXe[^X
    if(isopen(out_unit) /= 0) then
       write(*,*) "error: output file is not opened."
       stop
    end if

    if(debugflg) write(*,*) "output conditions"

    write(out_unit) nx, ny, nz, gmode, iobst
    write(out_unit) nphys
    do l = 1, nphys
       write(out_unit) trim(label(l)), dim(l)
    end do
    
    if(debugflg) write(*,*) "done..."

    !tO
    cur = "output_cond2d"

  end subroutine nayslib_output_cond2d

  !======================================================================
  !iq̏o
  !======================================================================
  subroutine nayslib_output_grid2d(nx, ny, xx, yy, z0, z1, iobst, obst)
    !ziq
    integer(4)   :: nz
    parameter(nz = 2)

    integer(4), intent(in) :: iobst                     !QtO
    integer(4), intent(in) :: nx, ny                    !iq: x(), y()
    integer(4), dimension(:,:), intent(in) :: obst      !\tO
    real(8), dimension(:,:), intent(in) :: xx, yy       !Wl: x, y
    real(8), dimension(:,:), intent(in) :: z0, z1       !z0(͏), z1()

    !o͗p3z
    real(8), dimension(1:nx, 1:ny, 1:nz) :: x3, y3, z3
    integer(4), dimension(1:nx-1, 1:ny-1, 1:nz-1) :: o3
    
    !JE^
    integer(4) :: i, j, k
    !--------------------------------------------------
    if(debugflg) write(*,*) "current status = ", trim(cur)

    !o̓t@Cւ̏o͏̊mF
    !Œiq
    if(gmode == 0) then
        if(trim(cur) /= "output_cond2d") then
	    write(*,*) "error: writing order for output file is wrong."
	    stop
	end if

    !ړiq
    else if(gmode == 1) then
        if(trim(cur) /= "output_time") then
	    write(*,*) "error: writing order for output file is wrong."
	    stop
	end if
    end if

    !t@CI[vXe[^X
    if(isopen(out_unit) /= 0) then
       write(*,*) "error: output file is not opened."
       stop
    end if

    if(debugflg) write(*,*) "output grid2d"

    !2z񂩂3zց@iq
    do j = 1, ny
       do i = 1, nx
          x3(i,j,1) = xx(i,j)
          x3(i,j,2) = xx(i,j)

          y3(i,j,1) = yy(i,j)
          y3(i,j,2) = yy(i,j)

          z3(i,j,1) = z0(i,j)
          z3(i,j,2) = z1(i,j)
       end do
    end do
    
    !2z񂩂3zց@QtO
    do k = 1, nz-1
       do j = 1, ny-1
          do i = 1, nx-1
             o3(i,j,k) = obst(i,j)
          end do
       end do
    end do

    write(out_unit) (((x3(i,j,k),i = 1, nx), j = 1, ny), k = 1, nz)&
          & ,(((y3(i,j,k),i = 1, nx), j = 1, ny), k = 1, nz)&
          & ,(((z3(i,j,k),i = 1, nx), j = 1, ny), k = 1, nz)
       
    !QZꍇ͏QZtOo
    if(iobst.ne.0) then
       write(out_unit) (((o3(i,j,k), i = 1, nx-1), j = 1, ny-1), k = 1, nz-1)
    end if

    if(debugflg) write(*,*) "done..."

    !tO
    cur = "output_grid2d"

  end subroutine nayslib_output_grid2d


  !======================================================================
  !xNgʂ̏o
  !======================================================================
  subroutine nayslib_output_vec2d(label, nx, ny, uu, vv)
    !ziq
    integer(4)   :: nz
    parameter(nz = 2)

    character(*), intent(in) :: label                   !ʂ̃x  
    integer(4), intent(in) :: nx, ny                    !iq          
    real(8), dimension(:,:), intent(in) :: uu, vv       !ʁixNgj

    !o͗p4z
    real(8), dimension(1:nx, 1:ny, 1:nz, 1:2) :: u4
    
    !JE^
    integer(4)   :: i, j, k, l
    !--------------------------------------------------
    if(debugflg) write(*,*) "current status = ", trim(cur)

    !o̓t@Cւ̏o͏̊mF
    !Œiq
    if(gmode == 0) then
        if(trim(cur) == "output_time" .or. trim(cur) == "output_vec2d" .or. trim(cur) == "output_scl2d") then
        else
	    write(*,*) "error: writing order for output file is wrong."
	    stop
	end if

    !ړiq
    else if(gmode == 1) then
        if(trim(cur) == "output_grid2d" .or. trim(cur) == "output_vec2d".or. trim(cur) == "output_scl2d" ) then
        else
	    write(*,*) "error: writing order for output file is wrong."
	    stop
	end if

    end if

    !t@CI[vXe[^X
    if(isopen(out_unit) /= 0) then
       write(*,*) "error: output file is not opened."
       stop
    end if

    if(debugflg) write(*,*) "output vector label : ", trim(label)

    !2z񂩂4z
    do j = 1, ny
       do i = 1, nx
          u4(i,j,1,1) = uu(i,j)
          u4(i,j,2,1) = uu(i,j)

          u4(i,j,1,2) = vv(i,j)
          u4(i,j,2,2) = vv(i,j)
       end do
    end do

    write(out_unit) trim(label)
    write(out_unit) ((((u4(i,j,k,l),i = 1, nx), j = 1, ny), k = 1, nz), l = 1, 2)

    !tO
    cur = "output_vec2d"

    if(debugflg) write(*,*) "done..."

  end subroutine nayslib_output_vec2d

  !======================================================================
  !XJ[ʂ̏o
  !======================================================================
  subroutine nayslib_output_scl2d(label, nx, ny, val)
    !ziq
    integer(4)   :: nz
    parameter(nz = 2)

    character(*), intent(in) :: label                   !ʂ̃x
    integer(4), intent(in) :: nx, ny                    !iq
    real(8), dimension(:,:), intent(in) :: val          !ʁiXJj  

    !o͗p3z
    real(8), dimension(1:nx, 1:ny, 1:nz) :: v3
    
    !JE^
    integer(4)   :: i, j, k, l
    !--------------------------------------------------
    if(debugflg) write(*,*) "current status = ", trim(cur)

    !o̓t@Cւ̏o͏̊mF
    !Œiq
    if(gmode == 0) then
        if(trim(cur) == "output_time" .or. trim(cur) == "output_vec2d" .or. trim(cur) == "output_scl2d") then
        else
	    write(*,*) "error: writing order for output file is wrong."
	    stop
	end if

    !ړiq
    else if(gmode == 1) then
        if(trim(cur) == "output_grid2d" .or. trim(cur) == "output_vec2d" .or. trim(cur) == "output_scl2d" ) then
        else
	    write(*,*) "error: writing order for output file is wrong."
	    stop
	end if
    end if

    !t@CI[vXe[^X
    if(isopen(out_unit) /= 0) then
       write(*,*) "error: output file is not opened."
       stop
    end if

    if(debugflg) write(*,*) "output scaler label : ", trim(label)

    !2z񂩂3z
    do j = 1, ny
       do i = 1, nx
          v3(i,j,1) = val(i,j)
          v3(i,j,2) = val(i,j)
       end do
    end do

    write(out_unit) trim(label)
    write(out_unit) (((v3(i,j,k),i = 1, nx), j = 1, ny), k = 1, nz)

    !tO
    cur = "output_scl2d"

    if(debugflg) write(*,*) "done..."

  end subroutine nayslib_output_scl2d


  !======================================================================
  !Naysp@o͏L
  !======================================================================
  subroutine nayslib_output_cond3d(nx, ny, nz, iobst, nphys, label, dim)
    integer(4), intent(in) :: iobst                     !QtOCiq̕ωtO
    integer(4), intent(in) :: nx, ny, nz                !iq: x(), y()
    integer(4), intent(in) :: nphys                     !o͕ʂ̐
    character(*), dimension(:), intent(in) :: label     !ʂ̃x
    integer(4), dimension(:), intent(in) :: dim         !ʂ̎

    !JE^
    integer(4) :: l
    !--------------------------------------------------
    if(debugflg) write(*,*) "current status = ", trim(cur)

    if(trim(cur) /= "open_output") then
        write(*,*) "error: writing order for output file is wrong."
	stop
    end if

    !t@CI[vXe[^X
    if(isopen(out_unit) /= 0) then
       write(*,*) "error: output file is not opened."
       stop
    end if

    if(debugflg) write(*,*) "output conditions"

    write(out_unit) nx, ny, nz, gmode, iobst
    write(out_unit) nphys
    do l = 1, nphys
       write(out_unit) trim(label(l)), dim(l)
    end do
    
    if(debugflg) write(*,*) "done..."

    !tO
    cur = "output_cond3d"

  end subroutine nayslib_output_cond3d

  !======================================================================
  !iq̏o
  !======================================================================
  subroutine nayslib_output_grid3d(nx, ny, nz, xx, yy, zz, iobst, obst)
    integer(4), intent(in) :: iobst                      !QtO
    integer(4), intent(in) :: nx, ny, nz                 !iq: x(), y()
    integer(4), dimension(:,:,:), intent(in) :: obst     !\tO
    real(8), dimension(:,:,:), intent(in) :: xx, yy, zz  !Wl: x, y
    
    !JE^
    integer(4) :: i, j, k
    !--------------------------------------------------
    if(debugflg) write(*,*) "current status = ", trim(cur)

    !o̓t@Cւ̏o͏̊mF
    !Œiq
    if(gmode == 0) then
        if(trim(cur) /= "output_cond3d") then
	    write(*,*) "error: writing order for output file is wrong."
	    stop
	end if

    !ړiq
    else if(gmode == 1) then
        if(trim(cur) /= "output_time") then
	    write(*,*) "error: writing order for output file is wrong."
	    stop
	end if
    end if

    !t@CI[vXe[^X
    if(isopen(out_unit) /= 0) then
       write(*,*) "error: output file is not opened."
       stop
    end if

    if(debugflg) write(*,*) "output grid3d"

    write(out_unit) (((xx(i,j,k),i = 1, nx), j = 1, ny), k = 1, nz)&
          & ,(((yy(i,j,k),i = 1, nx), j = 1, ny), k = 1, nz)&
          & ,(((zz(i,j,k),i = 1, nx), j = 1, ny), k = 1, nz)
       
    !QZꍇ͏QZtOo
    if(iobst.ne.0) then
       write(out_unit) (((obst(i,j,k), i = 1, nx-1), j = 1, ny-1), k = 1, nz-1)
    end if

    if(debugflg) write(*,*) "done..."

    !tO
    cur = "output_grid3d"

  end subroutine nayslib_output_grid3d


  !======================================================================
  !xNgʂ̏o
  !======================================================================
  subroutine nayslib_output_vec3d(label, nx, ny, nz, uu, vv, ww)
    character(*), intent(in) :: label                   !ʂ̃x  
    integer(4), intent(in) :: nx, ny, nz                !iq          
    real(8), dimension(:,:,:), intent(in) :: uu, vv, ww !ʁixNgj

    !o͗p4z
    real(8), dimension(1:nx, 1:ny, 1:nz, 1:3) :: u4
    
    !JE^
    integer(4)   :: i, j, k, l
    !--------------------------------------------------
    if(debugflg) write(*,*) "current status = ", trim(cur)

    !o̓t@Cւ̏o͏̊mF
    !Œiq
    if(gmode == 0) then
        if(trim(cur) == "output_time" .or. trim(cur) == "output_vec3d" .or. trim(cur) == "output_scl3d") then
        else
	    write(*,*) "error: writing order for output file is wrong."
	    stop
	end if

    !ړiq
    else if(gmode == 1) then
        if(trim(cur) == "output_grid3d" .or. trim(cur) == "output_vec3d" .or. trim(cur) == "output_scl3d" ) then
        else
	    write(*,*) "error: writing order for output file is wrong."
	    stop
	end if

    end if

    !t@CI[vXe[^X
    if(isopen(out_unit) /= 0) then
       write(*,*) "error: output file is not opened."
       stop
    end if

    if(debugflg) write(*,*) "output vector label : ", trim(label)

    !3z񂩂4z
    do k = 1, nz
       do j = 1, ny
          do i = 1, nx
             u4(i,j,k,1) = uu(i,j,k)
             u4(i,j,k,2) = vv(i,j,k)
             u4(i,j,k,3) = ww(i,j,k)
          end do
       end do
    end do

    write(out_unit) trim(label)
    write(out_unit) ((((u4(i,j,k,l),i = 1, nx), j = 1, ny), k = 1, nz), l = 1, 3)

    !tO
    cur = "output_vec3d"

    if(debugflg) write(*,*) "done..."

  end subroutine nayslib_output_vec3d

  !======================================================================
  !XJ[ʂ̏o
  !======================================================================
  subroutine nayslib_output_scl3d(label, nx, ny, nz, val)
    character(*), intent(in) :: label                   !ʂ̃x
    integer(4), intent(in) :: nx, ny, nz                !iq
    real(8), dimension(:,:,:), intent(in) :: val        !ʁiXJj  

    !JE^
    integer(4)   :: i, j, k, l
    !--------------------------------------------------
    if(debugflg) write(*,*) "current status = ", trim(cur)

    !o̓t@Cւ̏o͏̊mF
    !Œiq
    if(gmode == 0) then
        if(trim(cur) == "output_time" .or. trim(cur) == "output_vec3d" .or. trim(cur) == "output_scl3d" ) then
        else
	    write(*,*) "error: writing order for output file is wrong."
	    stop
	end if

    !ړiq
    else if(gmode == 1) then
        if(trim(cur) == "output_grid3d" .or. trim(cur) == "output_vec3d" .or. trim(cur) == "output_scl3d" ) then
        else
	    write(*,*) "error: writing order for output file is wrong."
	    stop
	end if

    end if

    !t@CI[vXe[^X
    if(isopen(out_unit) /= 0) then
       write(*,*) "error: output file is not opened."
       stop
    end if

    if(debugflg) write(*,*) "output scaler label : ", trim(label)

    write(out_unit) trim(label)
    write(out_unit) (((val(i,j,k),i = 1, nx), j = 1, ny), k = 1, nz)

    !tO
    cur = "output_scl3d"

    if(debugflg) write(*,*) "done..."

  end subroutine nayslib_output_scl3d

  !======================================================================
  !t@CXJĂǂmF
  !======================================================================
  integer function isopen(unit)
    integer(4) :: unit
    logical    :: flg

    !uԍ:unitJĂ邩ǂmF
    inquire( unit, opened=flg )

    !JĂȂ
    if(flg .EQV. .FALSE.) then
       isopen = -1
       
    !JĂ
    else
       isopen = 0
    end if

  end function isopen

  !======================================================================
  !󂫑uԍT
  !======================================================================
  integer function get_unit_no()
    integer :: unit
    logical :: flg

    !L̒T͈͓ɋ󂫂Ȃꍇ-1Ԃ
    get_unit_no = -1

    !199̑uԍ̂gpĂȂuԍT
    do unit = 10, 99
       inquire( unit, opened=flg )
       if ( flg .EQV. .FALSE. ) then
          get_unit_no = unit
       end if
    end do

  end function get_unit_no


  !==================================================
  !^Xg^̎擾
  !==================================================
  subroutine nayslib_get_integer_list(ifile, label, num, pval)
    implicit none
    character(*), intent(in) :: ifile, label
    integer(4) :: num
    integer(4), dimension(:), pointer :: pval

    integer(4) :: ifn, i, ios, ierr
    character(len = STRLEN) :: vname, type0, type1
    integer(4), dimension(:), allocatable, save :: val
    logical :: flg = .false.
    !
    ifn = get_unit_no()
    open(ifn, file=ifile)  
    rewind(ifn)
    do 
       read(ifn, *, IOSTAT = ios) vname, type0
       if(ios /= 0) exit
       
       !ϐxvƂ
       if(trim(vname) == trim(label)) then
          flg = .true.
          
          !^x
          if(trim(type0) == "list") then
             !1s߂
             backspace(ifn)
             read(ifn, *) vname, type0, num, type1
             if(type1 == "integer") then
                !
                !GÅm
                allocate(pval(1:num), stat = ierr)
                allocate(val(1:num), stat = ierr)
                if (ierr/=0)  then
                   write(*,*) 'error : fail to allocate stat=',ierr; stop   !GA擾ɎsƂ
                end if
                !
                !l̓ǂݍ
                backspace(ifn)
                read(ifn, *) vname, type0, num, type1, (val(i), i = 1, num)
                !|C^w
                pval = val
                close(ifn)
                return
             else
                write(*,*) "err:different type is specified."
                stop
             end if
          else
             write(*,*) "err:different type is specified."
             stop
          end if
       end if
    end do
    close(ifn)
    
    !w肳ꂽxȂƂ
    if(flg .EQV. .false.) then
       write(*,*) "err:specified label is not found."
       stop
    end if
    !
  end subroutine nayslib_get_integer_list

  !==================================================
  !^Xg^̎擾
  !==================================================
  subroutine nayslib_get_string_list(ifile, label, num, pval)
    implicit none
    character(*), intent(in) :: ifile, label
    integer(4) :: num
    character(len = STRLEN), dimension(:), pointer :: pval

    integer(4) :: ifn, i, ios, ierr
    character(len = STRLEN) :: vname, type0, type1
    character(len = STRLEN), dimension(:), allocatable, save :: val
    logical :: flg = .false.
    !
    ifn = get_unit_no()
    open(ifn, file=ifile)  
    rewind(ifn)
    do 
       read(ifn, *, IOSTAT = ios) vname, type0
       if(ios /= 0) exit
       
       !ϐxvƂ
       if(trim(vname) == trim(label)) then
          flg = .true.
          
          !^x
          if(trim(type0) == "list") then
             !1s߂
             backspace(ifn)
             read(ifn, *) vname, type0, num, type1
             if(type1 == "string") then
                !
                !GÅm
                allocate(pval(1:num), stat = ierr)
                allocate(val(1:num), stat = ierr)
                if (ierr/=0)  then
                   write(*,*) 'error : fail to allocate stat=',ierr; stop   !GA擾ɎsƂ
                end if
                !
                !l̓ǂݍ
                backspace(ifn)
                read(ifn, *) vname, type0, num, type1, (val(i), i = 1, num)
                !|C^w
                pval = val
                close(ifn)
                return
             else
                write(*,*) "err:different type is specified."
                stop
             end if
          else
             write(*,*) "err:different type is specified."
             stop
          end if
       end if
    end do
    close(ifn)
    
    !w肳ꂽxȂƂ
    if(flg .EQV. .false.) then
       write(*,*) "err:specified label is not found."
       stop
    end if
    !
  end subroutine nayslib_get_string_list

  !==================================================
  !^Xg^̎擾
  !==================================================
  subroutine nayslib_get_real_list(ifile, label, num, pval)
    implicit none
    character(*), intent(in) :: ifile, label
    integer(4) :: num
    real(8), dimension(:), pointer :: pval

    integer(4) :: ifn, i, ios, ierr
    character(len = STRLEN) :: vname, type0, type1
    real(8), dimension(:), allocatable, save :: val
    logical :: flg = .false.
    !
    ifn = get_unit_no()
    open(ifn, file=ifile)  
    rewind(ifn)
    do 
       read(ifn, *, IOSTAT = ios) vname, type0
       if(ios /= 0) exit
       
       !ϐxvƂ
       if(trim(vname) == trim(label)) then
          flg = .true.
          
          !^x
          if(trim(type0) == "list") then
             !1s߂
             backspace(ifn)
             read(ifn, *) vname, type0, num, type1
             if(type1 == "real") then
                !
                !GÅm
                allocate(pval(1:num), stat = ierr)
                allocate(val(1:num), stat = ierr)
                if (ierr/=0)  then
                   write(*,*) 'error : fail to allocate stat=',ierr; stop   !GA擾ɎsƂ
                end if
                !
                !l̓ǂݍ
                backspace(ifn)
                read(ifn, *) vname, type0, num, type1, (val(i), i = 1, num)
                !|C^w
                pval = val
                close(ifn)
                return
             else
                write(*,*) "err:different type is specified."
                stop
             end if
          else
             write(*,*) "err:different type is specified."
             stop
          end if
       end if
    end do
    close(ifn)
    
    !w肳ꂽxȂƂ
    if(flg .EQV. .false.) then
       write(*,*) "err:specified label is not found."
       stop
    end if
    !
  end subroutine nayslib_get_real_list

  !==================================================
  !_^Xg^̎擾
  !==================================================
  subroutine nayslib_get_logical_list(ifile, label, num, pval)
    implicit none
    character(*), intent(in) :: ifile, label
    integer(4) :: num
    logical, dimension(:), pointer :: pval

    integer(4) :: ifn, i, ios, ierr
    character(len = STRLEN) :: vname, type0, type1
    logical, dimension(:), allocatable, save :: val
    logical :: flg = .false.
    !
    ifn = get_unit_no()
    open(ifn, file=ifile)  
    rewind(ifn)
    do 
       read(ifn, *, IOSTAT = ios) vname, type0
       if(ios /= 0) exit
       
       !ϐxvƂ
       if(trim(vname) == trim(label)) then
          flg = .true.
          
          !^x
          if(trim(type0) == "list") then
             !1s߂
             backspace(ifn)
             read(ifn, *) vname, type0, num, type1
             if(type1 == "logical") then
                !
                !GÅm
                allocate(pval(1:num), stat = ierr)
                allocate(val(1:num), stat = ierr)
                if (ierr/=0)  then
                   write(*,*) 'error : fail to allocate stat=',ierr; stop   !GA擾ɎsƂ
                end if
                !
                !l̓ǂݍ
                backspace(ifn)
                read(ifn, *) vname, type0, num, type1, (val(i), i = 1, num)
                !|C^w
                pval = val
                close(ifn)
                return
             else
                write(*,*) "err:different type is specified."
                stop
             end if
          else
             write(*,*) "err:different type is specified."
             stop
          end if
       end if
    end do
    close(ifn)
    
    !w肳ꂽxȂƂ
    if(flg .EQV. .false.) then
       write(*,*) "err:specified label is not found."
       stop
    end if
    !
  end subroutine nayslib_get_logical_list

  !==================================================
  !t@C^̎擾
  !==================================================
  character(len = STRLEN) function nayslib_get_file(ifile, label)
    implicit none
    character(*), intent(in) :: ifile, label

    integer(4) :: ios, ifn
    character(len = STRLEN) :: vname, type
    logical :: flg = .false.
    !
    ifn = get_unit_no()
    open(ifn, file=ifile)  
    rewind(ifn)
    do 
       read(ifn, *, IOSTAT = ios) vname, type
       if(ios /= 0) exit
       
       !ϐxvƂ
       if(trim(vname) == trim(label)) then
          flg = .true.

          !^x
          if(trim(type) == "file") then
             !1s߂
             backspace(ifn)
             read(ifn, *) vname, type, nayslib_get_file
             close(ifn)
             return
          else
             write(*,*) "err:different type is specified."
             stop
          end if
       end if
    end do
    close(ifn)

    !w肳ꂽxȂƂ
    if(flg .EQV. .false.) then
       write(*,*) "err:specified label is not found."
       stop
    end if
    !
  end function nayslib_get_file

  !==================================================
  !^̎擾
  !==================================================
  character(len = STRLEN) function nayslib_get_string(ifile, label)
    implicit none
    character(*), intent(in) :: ifile, label

    integer(4) :: ios, ifn
    character(len = STRLEN) :: vname, type
    logical :: flg = .false.
    !
    ifn = get_unit_no()
    open(ifn, file=ifile)  
    rewind(ifn)
    do 
       read(ifn, *, IOSTAT = ios) vname, type
       if(ios /= 0) exit
       
       !ϐxvƂ
       if(trim(vname) == trim(label)) then
          flg = .true.

          !^x
          if(trim(type) == "string") then
             !1s߂
             backspace(ifn)
             read(ifn, *) vname, type, nayslib_get_string
             close(ifn)
             return
          else
             write(*,*) "err:different type is specified."
             stop
          end if
       end if
    end do
    close(ifn)

    !w肳ꂽxȂƂ
    if(flg .EQV. .false.) then
       write(*,*) "err:specified label is not found."
       stop
    end if
    !
  end function nayslib_get_string

  !==================================================
  !^̎擾
  !==================================================
  integer(4) function nayslib_get_integer(ifile, label)
    implicit none
    character(*), intent(in) :: ifile, label

    integer(4) :: ios, ifn
    character(len = STRLEN) :: vname, type
    logical :: flg = .false.
    !
    ifn = get_unit_no()
    open(ifn, file=ifile)  
    rewind(ifn)
    do 
       read(ifn, *, IOSTAT = ios) vname, type
       if(ios /= 0) exit
       
       !ϐxvƂ
       if(trim(vname) == trim(label)) then
          flg = .true.

          !^x
          if(trim(type) == "integer") then
             !1s߂
             backspace(ifn)
             read(ifn, *) vname, type, nayslib_get_integer
             close(ifn)
             return
          else
             write(*,*) "err:different type is specified."
             stop
          end if
       end if
    end do
    close(ifn)

    !w肳ꂽxȂƂ
    if(flg .EQV. .false.) then
       write(*,*) "err:specified label is not found."
       stop
    end if
    !
  end function nayslib_get_integer

  !==================================================
  !^̎擾
  !==================================================
  real(8) function nayslib_get_real(ifile, label)
    implicit none
    character(*), intent(in) :: ifile, label

    integer(4) :: ios, ifn
    character(len = STRLEN) :: vname, type
    logical :: flg = .false.
    !
    ifn = get_unit_no()
    open(ifn, file=ifile)  
    rewind(ifn)
    do 
       read(ifn, *, IOSTAT = ios) vname, type
       if(ios /= 0) exit
       
       !ϐxvƂ
       if(trim(vname) == trim(label)) then
          flg = .true.

          !^x
          if(trim(type) == "real") then
             !1s߂
             backspace(ifn)
             read(ifn, *) vname, type, nayslib_get_real
             close(ifn)
             return
          else
             write(*,*) "err:different type is specified."
             stop
          end if
       end if
    end do
    close(ifn)

    !w肳ꂽxȂƂ
    if(flg .EQV. .false.) then
       write(*,*) "err:specified label is not found."
       stop
    end if
    !
  end function nayslib_get_real

  !==================================================
  !_^̎擾
  !==================================================
  logical function nayslib_get_logical(ifile, label)
    implicit none
    character(*), intent(in) :: ifile, label

    integer(4) :: ios, ifn
    character(len = STRLEN) :: vname, type
    logical :: flg = .false.
    !
    ifn = get_unit_no()
    open(ifn, file=ifile)  
    rewind(ifn)
    do 
       read(ifn, *, IOSTAT = ios) vname, type
       if(ios /= 0) exit
       
       !ϐxvƂ
       if(trim(vname) == trim(label)) then
          flg = .true.

          !^x
          if(trim(type) == "logical") then
             !1s߂
             backspace(ifn)
             read(ifn, *) vname, type, nayslib_get_logical
             close(ifn)
             return
          else
             write(*,*) "err:different type is specified."
             stop
          end if
       end if
    end do
    close(ifn)

    !w肳ꂽxȂƂ
    if(flg .EQV. .false.) then
       write(*,*) "err:specified label is not found."
       stop
    end if
    !
  end function nayslib_get_logical
  
  !==================================================
  !񃊃Xg̎擾(condfile, "imode")
  !==================================================
  character(len = STRLEN) function nayslib_get_stringList(ifile, label)
    implicit none
    character(*), intent(in) :: ifile, label

    integer(4) :: ios, ifn
    character(len = STRLEN) :: vname, type
    logical :: flg = .false.
    !
    ifn = get_unit_no()
    open(ifn, file=ifile)  
    rewind(ifn)
    do 
       read(ifn, *, IOSTAT = ios) vname, type
       if(ios /= 0) exit
       
       !ϐxvƂ
       if(trim(vname) == trim(label)) then
          flg = .true.

          !^x
          if(trim(type) == "stringList") then
             !1s߂
             backspace(ifn)
             read(ifn, *) vname, type, nayslib_get_stringList
             close(ifn)
             return
          else
             write(*,*) "err:different type is specified."
             stop
          end if
       end if
    end do
    close(ifn)

    !w肳ꂽxȂƂ
    if(flg .EQV. .false.) then
       write(*,*) "err:specified label is not found."
       stop
    end if
    !
  end function nayslib_get_stringList

  !==================================================
  !^Xg̎擾
  !==================================================
  integer(4) function nayslib_get_integerList(ifile, label)
    implicit none
    character(*), intent(in) :: ifile, label

    integer(4) :: ios, ifn
    character(len = STRLEN) :: vname, type
    logical :: flg = .false.
    !
    ifn = get_unit_no()
    open(ifn, file=ifile)  
    rewind(ifn)
    do 
       read(ifn, *, IOSTAT = ios) vname, type
       if(ios /= 0) exit
       
       !ϐxvƂ
       if(trim(vname) == trim(label)) then
          flg = .true.

          !^x
          if(trim(type) == "integerList") then
             !1s߂
             backspace(ifn)
             read(ifn, *) vname, type, nayslib_get_integerList
             close(ifn)
             return
          else
             write(*,*) "err:different type is specified."
             stop
          end if
       end if
    end do
    close(ifn)

    !w肳ꂽxȂƂ
    if(flg .EQV. .false.) then
       write(*,*) "err:specified label is not found."
       stop
    end if
    !
  end function nayslib_get_integerList

  !==================================================
  !^Xg̎擾
  !==================================================
  real(8) function nayslib_get_realList(ifile, label)
    implicit none
    character(*), intent(in) :: ifile, label

    integer(4) :: ios, ifn
    character(len = STRLEN) :: vname, type
    logical :: flg = .false.
    !
    ifn = get_unit_no()
    open(ifn, file=ifile)  
    rewind(ifn)
    do 
       read(ifn, *, IOSTAT = ios) vname, type
       if(ios /= 0) exit
       
       !ϐxvƂ
       if(trim(vname) == trim(label)) then
          flg = .true.

          !^x
          if(trim(type) == "realList") then
             !1s߂
             backspace(ifn)
             read(ifn, *) vname, type, nayslib_get_realList
             close(ifn)
             return
          else
             write(*,*) "err:different type is specified."
             stop
          end if
       end if
    end do
    close(ifn)

    !w肳ꂽxȂƂ
    if(flg .EQV. .false.) then
       write(*,*) "err:specified label is not found."
       stop
    end if
    !
  end function nayslib_get_realList

end module nayslib
